searchNodes=[{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Usage You can construct a reactor using the Reactor Spark DSL: defmodule HelloWorldReactor do @moduledoc false use Reactor input :whom step :greet , Greeter do argument :whom , input ( :whom ) end return :greet end iex&gt; Reactor . run ( HelloWorldReactor , %{ whom : &quot;Dear Reader&quot; } ) { :ok , &quot;Hello, Dear Reader!&quot; } or you can build it programmatically: iex&gt; reactor = Builder . new ( ) ...&gt; { :ok , reactor } = Builder . add_input ( reactor , :whom ) ...&gt; { :ok , reactor } = Builder . add_step ( reactor , :greet , Greeter , whom : { :input , :whom } ) ...&gt; { :ok , reactor } = Builder . return ( reactor , :greet ) ...&gt; Reactor . run ( reactor , %{ whom : nil } ) { :ok , &quot;Hello, World!&quot; } DSL Documentation Index reactor around argument group argument input step argument compose argument Docs reactor The top-level reactor DSL around argument group argument input step argument compose argument :return ( atom/0 ) - Specify which step result to return upon completion. around Wrap a function around a group of steps. argument :name ( atom/0 ) - Required. A unique name of the group of steps. :fun - Required. The around function. See Reactor.Step.Around for more information. :allow_async? ( boolean/0 ) - Whether the emitted steps should be allowed to run asynchronously. Passed to the child Reactor as it's async? option. The default value is false . argument Specifies an argument to a Reactor step. Each argument is a value which is either the result of another step, or an input value. Individual arguments can be transformed with an arbitrary function before being passed to any steps. Examples: argument :name , input ( :name ) argument :user , result ( :create_user ) argument :user_id , result ( :create_user ) do transform &amp; &amp;1 . id end argument :three , value ( 3 ) :name ( atom/0 ) - Required. The name of the argument which will be used as the key in the arguments map passed to the implementation. :source - Required. What to use as the source of the argument. See Reactor.Dsl.Argument for more information. :transform - An optional transformation function which can be used to modify the argument before it is passed to the step. The default value is nil . group Call functions before and after a group of steps. argument :name ( atom/0 ) - Required. A unique name for the group of steps. :before_all - Required. The before function. See Reactor.Step.Group for more information. :after_all - Required. The after function. See Reactor.Step.Group for more information. :allow_async? ( boolean/0 ) - Whether the emitted steps should be allowed to run asynchronously. Passed to the child Reactor as it's async? option. The default value is true . argument Specifies an argument to a Reactor step. Each argument is a value which is either the result of another step, or an input value. Individual arguments can be transformed with an arbitrary function before being passed to any steps. Examples: argument :name , input ( :name ) argument :user , result ( :create_user ) argument :user_id , result ( :create_user ) do transform &amp; &amp;1 . id end argument :three , value ( 3 ) :name ( atom/0 ) - Required. The name of the argument which will be used as the key in the arguments map passed to the implementation. :source - Required. What to use as the source of the argument. See Reactor.Dsl.Argument for more information. :transform - An optional transformation function which can be used to modify the argument before it is passed to the step. The default value is nil . input Specifies an input to the Reactor. An input is a value passed in to the Reactor when executing. If a Reactor were a function, these would be it's arguments. Inputs can be transformed with an arbitrary function before being passed to any steps. Examples: input :name input :age do transform &amp; String . to_integer / 1 end :name ( atom/0 ) - Required. A unique name for this input. The name is used to allow steps to depend on it. :transform - An optional transformation function which can be used to modify the input before it is passed to any steps. The default value is nil . step Specifies a Reactor step. Steps are the unit of work in a Reactor. Reactor will calculate the dependencies graph between the steps and execute as many as it can in each iteration. See the Reactor.Step behaviour for more information. argument Examples: step :create_user , MyApp.Steps.CreateUser do argument :username , input ( :username ) argument :password_hash , result ( :hash_password ) end step :hash_password do argument :password , input ( :password ) run fn %{ password : password } , _ -&gt; { :ok , Bcrypt . hash_pwd_salt ( password ) } end end :name ( atom/0 ) - Required. A unique name for the step. This is used when choosing the return value of the Reactor and for arguments into another step. :impl - The step implementation. Provides an implementation for the step with the named module. The module must implement the Reactor.Step behaviour. :run - Provide an anonymous function which implements the run/3 callback. You cannot provide this option at the same time as the impl argument. :undo - Provide an anonymous function which implements the undo/4 callback. You cannot provide this option at the same time as the impl argument. :compensate - Provide an anonymous function which implements the undo/4 callback. You cannot provide this option at the same time as the impl argument. :max_retries - The maximum number of times that the step can be retried before failing. This is only used when the result of the compensate/4 callback is :retry . The default value is :infinity . :async? ( boolean/0 ) - When set to true the step will be executed asynchronously via Reactor's TaskSupervisor . The default value is true . :transform - An optional transformation function which can be used to modify the entire argument map before it is passed to the step. The default value is nil . argument Specifies an argument to a Reactor step. Each argument is a value which is either the result of another step, or an input value. Individual arguments can be transformed with an arbitrary function before being passed to any steps. Examples: argument :name , input ( :name ) argument :user , result ( :create_user ) argument :user_id , result ( :create_user ) do transform &amp; &amp;1 . id end argument :three , value ( 3 ) :name ( atom/0 ) - Required. The name of the argument which will be used as the key in the arguments map passed to the implementation. :source - Required. What to use as the source of the argument. See Reactor.Dsl.Argument for more information. :transform - An optional transformation function which can be used to modify the argument before it is passed to the step. The default value is nil . compose Compose another Reactor into this one. Allows place another Reactor into this one as if it were a single step. argument :name ( atom/0 ) - Required. A unique name for the step. Allows the result of the composed reactor to be depended upon by steps in this reactor. :reactor - Required. The reactor module or struct to compose upon. argument Specifies an argument to a Reactor step. Each argument is a value which is either the result of another step, or an input value. Individual arguments can be transformed with an arbitrary function before being passed to any steps. Examples: argument :name , input ( :name ) argument :user , result ( :create_user ) argument :user_id , result ( :create_user ) do transform &amp; &amp;1 . id end argument :three , value ( 3 ) :name ( atom/0 ) - Required. The name of the argument which will be used as the key in the arguments map passed to the implementation. :source - Required. What to use as the source of the argument. See Reactor.Dsl.Argument for more information. :transform - An optional transformation function which can be used to modify the argument before it is passed to the step. The default value is nil .","ref":"Reactor.html","title":"Reactor","type":"module"},{"doc":"Run a reactor.","ref":"Reactor.html#run/4","title":"Reactor.run/4","type":"function"},{"doc":"When set to false forces the Reactor to run every step synchronously, regardless of the step configuration. Defaults to true .","ref":"Reactor.html#t:async_option/0","title":"Reactor.async_option/0","type":"type"},{"doc":"Use a Reactor.Executor.ConcurrencyTracker.pool_key to allow this Reactor to share it's concurrency pool with other Reactor instances. If you do not specify one then the Reactor will initialise a new pool and place it in it's context for any child Reactors to re-use. Only used if async? is set to true .","ref":"Reactor.html#t:concurrency_key_option/0","title":"Reactor.concurrency_key_option/0","type":"type"},{"doc":"","ref":"Reactor.html#t:context/0","title":"Reactor.context/0","type":"type"},{"doc":"","ref":"Reactor.html#t:context_arg/0","title":"Reactor.context_arg/0","type":"type"},{"doc":"How long to wait for asynchronous steps to complete when halting. Defaults to 5000ms.","ref":"Reactor.html#t:halt_timeout_option/0","title":"Reactor.halt_timeout_option/0","type":"type"},{"doc":"","ref":"Reactor.html#t:inputs/0","title":"Reactor.inputs/0","type":"type"},{"doc":"Specify the maximum number of asynchronous steps which can be run in parallel. Defaults to the result of System.schedulers_online/0 . Only used if async? is set to true .","ref":"Reactor.html#t:max_concurrency_option/0","title":"Reactor.max_concurrency_option/0","type":"type"},{"doc":"The maximum number of iterations which after which the Reactor will halt. Defaults to :infinity .","ref":"Reactor.html#t:max_iterations_option/0","title":"Reactor.max_iterations_option/0","type":"type"},{"doc":"","ref":"Reactor.html#t:options/0","title":"Reactor.options/0","type":"type"},{"doc":"","ref":"Reactor.html#t:state/0","title":"Reactor.state/0","type":"type"},{"doc":"","ref":"Reactor.html#t:t/0","title":"Reactor.t/0","type":"type"},{"doc":"Specify the amount of execution time after which to halt processing. Note that this is not a hard limit. The Reactor will stop when the first step completes after the timeout has expired. Defaults to :infinity .","ref":"Reactor.html#t:timeout_option/0","title":"Reactor.timeout_option/0","type":"type"},{"doc":"The Step behaviour and struct. Implement this behaviour to make steps for your Reactor.","ref":"Reactor.Step.html","title":"Reactor.Step","type":"behaviour"},{"doc":"Find out of a step has a capability.","ref":"Reactor.Step.html#can?/2","title":"Reactor.Step.can?/2","type":"function"},{"doc":"Compensate a step","ref":"Reactor.Step.html#compensate/4","title":"Reactor.Step.compensate/4","type":"function"},{"doc":"Compensate for the failure of the step. Do not implement this callback if your step doesn't support compensation. If run/3 returned an error then this callback will be called the error reason and the original arguments. This provides you the opportunity to handle the error in a number of ways and direct the reactor as to what to do next. Arguments reason - the error reason returned from run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values {:continue, value} if you're able to provide a valid result for the step (perhaps by re-running the original computation) then return that within a :continue tuple and execution will continue as planned. :ok the step was successfully compensated and the reactor should continue undoing upstream changes. :retry if you would like the reactor to attempt to re-run the step.","ref":"Reactor.Step.html#c:compensate/4","title":"Reactor.Step.compensate/4","type":"callback"},{"doc":"Execute a step.","ref":"Reactor.Step.html#run/3","title":"Reactor.Step.run/3","type":"function"},{"doc":"Execute the step. This is the function that implements the behaviour you wish to execute. You will receive arguments as per the t:Step.t definition along with their corresponding values as a map and a copy of the current reactor context. Arguments arguments - A map of arguments as per the t:Step.t definition we're called from. context - The reactor context. options - A keyword list of options provided to the step (if any). Return values {:ok, value} the step completed successfully it returns the value in an ok tuple. {:ok, value, [step]} the step completed successfully and wants to add new steps to the reactor. {:error, reason} the if step failed, return an error tuple. {:halt, reason} terminate (or pause) reactor execution. If there are actively running steps the reactor will wait for them to finish and then return the incomplete state for later resumption.","ref":"Reactor.Step.html#c:run/3","title":"Reactor.Step.run/3","type":"callback"},{"doc":"Undo a step","ref":"Reactor.Step.html#undo/4","title":"Reactor.Step.undo/4","type":"function"},{"doc":"Undo a previously successful execution of the step. Do not implement this callback if your step doesn't support undoing. This callback is called when the reactor encounters an unhandled error later in it's execution run and must undo the work previously done. Arguments value - the return value of the previously successful call to run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values :ok the step was successfully undo and the reactor should continue rolling back. {:error, reason} there was an error while attempting to compensate. The reactor will collect the error and continue rolling back. :retry if you would like the reactor to attempt to undo the again later possibly in the case of a network failure for example.","ref":"Reactor.Step.html#c:undo/4","title":"Reactor.Step.undo/4","type":"callback"},{"doc":"Optional capabilities which may be implemented by the step module. This allows us to optimise out calls steps which cannot be undone, etc.","ref":"Reactor.Step.html#t:capability/0","title":"Reactor.Step.capability/0","type":"type"},{"doc":"Possible valid return values for the compensate/4 callback.","ref":"Reactor.Step.html#t:compensate_result/0","title":"Reactor.Step.compensate_result/0","type":"type"},{"doc":"Possible valid return values for the run/3 callback.","ref":"Reactor.Step.html#t:run_result/0","title":"Reactor.Step.run_result/0","type":"type"},{"doc":"","ref":"Reactor.Step.html#t:step/0","title":"Reactor.Step.step/0","type":"type"},{"doc":"","ref":"Reactor.Step.html#t:t/0","title":"Reactor.Step.t/0","type":"type"},{"doc":"Possible valid return values for the undo/4 callback.","ref":"Reactor.Step.html#t:undo_result/0","title":"Reactor.Step.undo_result/0","type":"type"},{"doc":"The built-in step for executing in-line DSL anonymous functions. This step assumes that it is being called as per the :spark_function_behaviour semantics.","ref":"Reactor.Step.AnonFn.html","title":"Reactor.Step.AnonFn","type":"module"},{"doc":"Wrap the execution of a number of steps in a function. This allows you to provide custom context and filter the provided steps as needed. Options fun - a four-arity function that will be called when executing this step. steps - a list of steps which are will be provided to the above mentioned function. allow_async? - a boolean indicating whether the nested steps can be executed asynchronously or must remain within the current process. Wrapper function Your around function will be called by this step and will be passed the following arguments: arguments - the arguments passed to the step. context - the context passed to the step. steps - the list of steps passed in the options. callback - a 3 arity function that you can call to execute steps. This provides you the opportunity to modify the arguments, context and list of steps to be executed. You then can call the callback with the modified arguments, context and steps and they will be executed in a Reactor of their own. The callback will return {:ok, results} where results is a map of all of the step results by name, or an error tuple. You can then modify the result in any way before returning it as the return of the around step. Callback function The callback function will spawn a separate Reactor and run provided steps to completion using arguments as input. It expects the following three arguments to be passed: arguments - a map of arguments to be used as input to the nested Reactor. context - the context passed to the nested Reactor. steps - the list of steps which will be executed in the nested Reactor. Example You could use a function like that below to cause some steps to be executed inside an Ecto database transaction. def in_transaction ( arguments , context , steps , callback ) do MyApp.Repo . transaction ( fn -&gt; case callback . ( arguments , context , steps ) do { :ok , results } -&gt; result { :error , reason } -&gt; raise reason end end ) end","ref":"Reactor.Step.Around.html","title":"Reactor.Step.Around","type":"module"},{"doc":"","ref":"Reactor.Step.Around.html#around/4","title":"Reactor.Step.Around.around/4","type":"function"},{"doc":"Should the inner Reactor be allowed to run tasks asynchronously? Optional. Defaults to true .","ref":"Reactor.Step.Around.html#t:allow_async_option/0","title":"Reactor.Step.Around.allow_async_option/0","type":"type"},{"doc":"The type signature for the &quot;around&quot; function.","ref":"Reactor.Step.Around.html#t:around_fun/0","title":"Reactor.Step.Around.around_fun/0","type":"type"},{"doc":"The type signature for the provided callback function.","ref":"Reactor.Step.Around.html#t:callback/0","title":"Reactor.Step.Around.callback/0","type":"type"},{"doc":"The MFA or 4-arity function which this step will call.","ref":"Reactor.Step.Around.html#t:function_option/0","title":"Reactor.Step.Around.function_option/0","type":"type"},{"doc":"","ref":"Reactor.Step.Around.html#t:options/0","title":"Reactor.Step.Around.options/0","type":"type"},{"doc":"The initial steps to pass into the &quot;around&quot; function. Optional.","ref":"Reactor.Step.Around.html#t:steps_option/0","title":"Reactor.Step.Around.steps_option/0","type":"type"},{"doc":"A built-in step which can embed one reactor inside another. This is different to the Builder.compose and DSL compose methods. Those methods build a new reactor by combining the steps of the two input reactors, whereas this step expands the provided reactor at runtime and dynamically inserts it's steps into the running reactor. If emitting the reactor's steps into the current reactor would be recursive, then the reactor is directly executed within the step using Reactor.run/4 .","ref":"Reactor.Step.Compose.html","title":"Reactor.Step.Compose","type":"module"},{"doc":"When doing run-time composition of Reactors we need to dynamically rewrite any dynamically emitted steps to have the correct namespace. Yes, this gets hairy, fast. This is dynamically injected into steps by Reactor.Step.Compose - you probably don't want to use this unless you're sure what you're doing. Options original - the original value of the Step's impl key. prefix - a list of values to be placed in the name before the original value.","ref":"Reactor.Step.ComposeWrapper.html","title":"Reactor.Step.ComposeWrapper","type":"module"},{"doc":"Wrap the execution of a number of steps with before/after functions. Unlike Reactor.Step.Around , this step doesn't need to run a nested Reactor instance, but instead can emit the steps directly into the parent Reactor. Options before - a three-arity function that will be called before running any child steps. after - a three-arity function that will be called after running any emitted steps. allow_async? - a boolean indicating whether the emitted steps can be executed asynchronously or must remain within the current process. Before function The before function will be passed the following arguments: arguments - the values of any step arguments needed by the group. context - the Reactor context. steps - the list of steps passed in the options. This provides you the opportunity to modify the arguments, context and list of steps to be executed. The successful return value should be {:ok, arguments, context, steps} . The returned arguments will be used to provide any input arguments to nested steps. Example def no_time_travel ( arguments , context , steps ) do steps = steps |&gt; Enum . filter ( &amp; ( &amp;1 . name == :program_time_circuits ) ) arguments = arguments |&gt; Map . delete ( :destination_time ) { :ok , arguments , context , steps } end After function The after function will be called with a single argument; a map of the nested step results. The successful return value should be {:ok, any} where any will be treated as the result of the group. def find_current_year ( results ) do case Map . fetch ( results , :time_circuits ) do { :ok , %{ present_time : present_time } } -&gt; { :ok , present_time . year } _ -&gt; { :error , &quot;Unable to read the present time from the time circuits&quot; } end end","ref":"Reactor.Step.Group.html","title":"Reactor.Step.Group","type":"module"},{"doc":"The after function.","ref":"Reactor.Step.Group.html#t:after_fun/0","title":"Reactor.Step.Group.after_fun/0","type":"type"},{"doc":"The MFA or 1-arity function which this step will call after successfully running the steps.","ref":"Reactor.Step.Group.html#t:after_option/0","title":"Reactor.Step.Group.after_option/0","type":"type"},{"doc":"Should the emitted steps be allowed to run asynchronously? Optional. Defaults to true .","ref":"Reactor.Step.Group.html#t:allow_async_option/0","title":"Reactor.Step.Group.allow_async_option/0","type":"type"},{"doc":"The before function.","ref":"Reactor.Step.Group.html#t:before_fun/0","title":"Reactor.Step.Group.before_fun/0","type":"type"},{"doc":"The MFA or 3-arity function which this step will call before running any steps.","ref":"Reactor.Step.Group.html#t:before_option/0","title":"Reactor.Step.Group.before_option/0","type":"type"},{"doc":"","ref":"Reactor.Step.Group.html#t:options/0","title":"Reactor.Step.Group.options/0","type":"type"},{"doc":"The initial steps to pass into the &quot;before&quot; function. Optional.","ref":"Reactor.Step.Group.html#t:steps_option/0","title":"Reactor.Step.Group.steps_option/0","type":"type"},{"doc":"A very simple step which simply returns all it's arguments unchanged.","ref":"Reactor.Step.ReturnAllArguments.html","title":"Reactor.Step.ReturnAllArguments","type":"module"},{"doc":"The built-in step for executing input and argument transformations. This step assumes that it is being executed as per :spark_function_behaviour semantics.","ref":"Reactor.Step.Transform.html","title":"Reactor.Step.Transform","type":"module"},{"doc":"A built-in step which applies a transformation function to all it's arguments. The returned map is used as the arguments to the step, instead of the step's defined arguments.","ref":"Reactor.Step.TransformAll.html","title":"Reactor.Step.TransformAll","type":"module"},{"doc":"A step argument.","ref":"Reactor.Argument.html","title":"Reactor.Argument","type":"module"},{"doc":"Build an argument which refers to a reactor input with an optional transformation applied. Example iex&gt; Argument . from_input ( :argument_name , :input_name , &amp; String . to_integer / 1 )","ref":"Reactor.Argument.html#from_input/3","title":"Reactor.Argument.from_input/3","type":"function"},{"doc":"Build an argument which refers to the result of another step with an optional transformation applied. Example iex&gt; Argument . from_result ( :argument_name , :step_name , &amp; Atom . to_string / 1 )","ref":"Reactor.Argument.html#from_result/3","title":"Reactor.Argument.from_result/3","type":"function"},{"doc":"Build an argument which refers to a statically defined value. Example iex&gt; Argument . from_value ( :argument_name , 10 )","ref":"Reactor.Argument.html#from_value/3","title":"Reactor.Argument.from_value/3","type":"function"},{"doc":"Validate that the argument has a transform.","ref":"Reactor.Argument.html#has_transform/1","title":"Reactor.Argument.has_transform/1","type":"macro"},{"doc":"Validate that the argument is an Argument struct.","ref":"Reactor.Argument.html#is_argument/1","title":"Reactor.Argument.is_argument/1","type":"macro"},{"doc":"Validate that the argument refers to a reactor input.","ref":"Reactor.Argument.html#is_from_input/1","title":"Reactor.Argument.is_from_input/1","type":"macro"},{"doc":"Validate that the argument refers to a step result.","ref":"Reactor.Argument.html#is_from_result/1","title":"Reactor.Argument.is_from_result/1","type":"macro"},{"doc":"Validate that the argument contains a static value.","ref":"Reactor.Argument.html#is_from_value/1","title":"Reactor.Argument.is_from_value/1","type":"macro"},{"doc":"","ref":"Reactor.Argument.html#t:t/0","title":"Reactor.Argument.t/0","type":"type"},{"doc":"A protocol which can be used to convert something into an argument.","ref":"Reactor.Argument.Build.html","title":"Reactor.Argument.Build","type":"protocol"},{"doc":"Convert the input into an argument.","ref":"Reactor.Argument.Build.html#build/1","title":"Reactor.Argument.Build.build/1","type":"function"},{"doc":"","ref":"Reactor.Argument.Build.html#t:t/0","title":"Reactor.Argument.Build.t/0","type":"type"},{"doc":"Build a new Reactor programmatically. You don't have to use the Reactor DSL to create a Reactor. The functions in this module allow you to define a Reactor programmatically. This is especially useful if you need to create a reactor dynamically (maybe based on a UI such as React Flow ). Example reactor = Builder . new ( ) { :ok , reactor } = Builder . add_input ( reactor , :name ) argument = Argument . from_input ( :name ) { :ok , reactor } = Builder . add_step ( reactor , :greet , [ argument ] ) { :ok , reactor } = Builder . return ( reactor , :greet )","ref":"Reactor.Builder.html","title":"Reactor.Builder","type":"module"},{"doc":"Add a named input to the Reactor. This both places the input in the Reactor for later input validation and adds steps to the Reactor which will emit and (possibly) transform the input.","ref":"Reactor.Builder.html#add_input/3","title":"Reactor.Builder.add_input/3","type":"function"},{"doc":"Raising version of add_input/2..3 .","ref":"Reactor.Builder.html#add_input!/3","title":"Reactor.Builder.add_input!/3","type":"function"},{"doc":"Add a step to the Reactor. Add a new step to the Reactor. Rewrites input arguments to use the result of the input steps and injects transformation steps as required.","ref":"Reactor.Builder.html#add_step/5","title":"Reactor.Builder.add_step/5","type":"function"},{"doc":"Raising version of add_step/3..5 .","ref":"Reactor.Builder.html#add_step!/5","title":"Reactor.Builder.add_step!/5","type":"function"},{"doc":"Compose another Reactor inside this one. Whenever possible this function will extract the steps from inner Reactor and place them inside the parent Reactor. In order to achieve this the composer will rename the steps to ensure that there are no conflicts. If you're attempting to create a recursive Reactor (ie compose a Reactor within itself) then this will be detected and runtime composition will be used instead. See Reactor.Step.Compose for more details.","ref":"Reactor.Builder.html#compose/4","title":"Reactor.Builder.compose/4","type":"function"},{"doc":"Raising version of compose/4 .","ref":"Reactor.Builder.html#compose!/4","title":"Reactor.Builder.compose!/4","type":"function"},{"doc":"Build a new, empty Reactor. Optionally an identifier for the Reactor. This is primarily used for recursive composition tracking.","ref":"Reactor.Builder.html#new/1","title":"Reactor.Builder.new/1","type":"function"},{"doc":"Build a step which can be added to a reactor at runtime. Note that the built step doesn't support transformations - you should add an additional step to do the transformation needed (this is what add_step/5 does anyway).","ref":"Reactor.Builder.html#new_step/4","title":"Reactor.Builder.new_step/4","type":"function"},{"doc":"Raising version of new_step/2..4 .","ref":"Reactor.Builder.html#new_step!/4","title":"Reactor.Builder.new_step!/4","type":"function"},{"doc":"Specify the return value of the Reactor. The return value must be the name of a step.","ref":"Reactor.Builder.html#return/2","title":"Reactor.Builder.return/2","type":"function"},{"doc":"Raising version of return/2 .","ref":"Reactor.Builder.html#return!/2","title":"Reactor.Builder.return!/2","type":"function"},{"doc":"Optionally transform all the arguments into new arguments","ref":"Reactor.Builder.html#t:arguments_transform/0","title":"Reactor.Builder.arguments_transform/0","type":"type"},{"doc":"Should the step be run asynchronously?","ref":"Reactor.Builder.html#t:async?/0","title":"Reactor.Builder.async?/0","type":"type"},{"doc":"Optional context which will be merged with the reactor context when calling this step.","ref":"Reactor.Builder.html#t:context/0","title":"Reactor.Builder.context/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:impl/0","title":"Reactor.Builder.impl/0","type":"type"},{"doc":"How many times is the step allowed to retry?","ref":"Reactor.Builder.html#t:max_retries/0","title":"Reactor.Builder.max_retries/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:ref/0","title":"Reactor.Builder.ref/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_argument/0","title":"Reactor.Builder.step_argument/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_options/0","title":"Reactor.Builder.step_options/0","type":"type"},{"doc":"Handle composition of Reactors for the builder. The composition logic was getting complicated enough that it seemed sensible to extract it from the builder - if only to aid readability. You should not use this module directly, but instead use Reactor.Builder.compose/4 .","ref":"Reactor.Builder.Compose.html","title":"Reactor.Builder.Compose","type":"module"},{"doc":"Compose another Reactor inside this one.","ref":"Reactor.Builder.Compose.html#compose/4","title":"Reactor.Builder.Compose.compose/4","type":"function"},{"doc":"","ref":"Reactor.Builder.Compose.html#do_static_compose/4","title":"Reactor.Builder.Compose.do_static_compose/4","type":"function"},{"doc":"Handle adding inputs to Reactors for the builder. You should not use this module directly, but instead use Reactor.Builder.add_input/3 .","ref":"Reactor.Builder.Input.html","title":"Reactor.Builder.Input","type":"module"},{"doc":"Add a named input to the reactor.","ref":"Reactor.Builder.Input.html#add_input/3","title":"Reactor.Builder.Input.add_input/3","type":"function"},{"doc":"Handle building and adding steps to Reactors for the builder. You should not use this module directly, but instead use Reactor.Builder.new_step/4 and Reactor.Builder.add_step/5 .","ref":"Reactor.Builder.Step.html","title":"Reactor.Builder.Step","type":"module"},{"doc":"Build and add a new step to a Reactor.","ref":"Reactor.Builder.Step.html#add_step/5","title":"Reactor.Builder.Step.add_step/5","type":"function"},{"doc":"Dynamically build a new step for later use. You're most likely to use this when dynamically returning new steps from an existing step.","ref":"Reactor.Builder.Step.html#new_step/4","title":"Reactor.Builder.Step.new_step/4","type":"function"},{"doc":"The struct used to store argument DSL entities. See d:Reactor.step.argument .","ref":"Reactor.Dsl.Argument.html","title":"Reactor.Dsl.Argument","type":"module"},{"doc":"The input template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor input :name step :greet do # here: --------↓↓↓↓↓ argument :name , input ( :name ) run fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Dsl.Argument.html#input/1","title":"Reactor.Dsl.Argument.input/1","type":"function"},{"doc":"The result template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor step :whom do run fn -&gt; { :ok , Enum . random ( [ &quot;Marty&quot; , &quot;Doc&quot; , &quot;Jennifer&quot; , &quot;Lorraine&quot; , &quot;George&quot; , nil ] ) } end end step :greet do # here: --------↓↓↓↓↓↓ argument :name , result ( :whom ) run fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Dsl.Argument.html#result/1","title":"Reactor.Dsl.Argument.result/1","type":"function"},{"doc":"The value template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor input :number step :times_three do argument :lhs , input ( :number ) # here: -------↓↓↓↓↓ argument :rhs , value ( 3 ) run fn args , _ , _ -&gt; { :ok , args . lhs * args . rhs } end end end","ref":"Reactor.Dsl.Argument.html#value/1","title":"Reactor.Dsl.Argument.value/1","type":"function"},{"doc":"","ref":"Reactor.Dsl.Argument.html#t:t/0","title":"Reactor.Dsl.Argument.t/0","type":"type"},{"doc":"The around DSL entity struct. See d:Reactor.around .","ref":"Reactor.Dsl.Around.html","title":"Reactor.Dsl.Around","type":"module"},{"doc":"","ref":"Reactor.Dsl.Around.html#t:t/0","title":"Reactor.Dsl.Around.t/0","type":"type"},{"doc":"A protocol which DSL entities must implement.","ref":"Reactor.Dsl.Build.html","title":"Reactor.Dsl.Build","type":"protocol"},{"doc":"Build an entity into a Reactor. This function is called during conversion of a DSL module into a Reactor struct. This allows extensions to specify the behaviour of how they want to alter the structure of the Reactor.","ref":"Reactor.Dsl.Build.html#build/2","title":"Reactor.Dsl.Build.build/2","type":"function"},{"doc":"Perform any transformation that is needed to make the entity work in the system before building. See Spark.Dsl.Transformer for more information.","ref":"Reactor.Dsl.Build.html#transform/2","title":"Reactor.Dsl.Build.transform/2","type":"function"},{"doc":"Perform any after-compilation verification that is needed to make the entity work. See Spark.Dsl.Verifier for more information.","ref":"Reactor.Dsl.Build.html#verify/2","title":"Reactor.Dsl.Build.verify/2","type":"function"},{"doc":"","ref":"Reactor.Dsl.Build.html#t:t/0","title":"Reactor.Dsl.Build.t/0","type":"type"},{"doc":"The compose DSL entity struct. See the d:Reactor.compose .","ref":"Reactor.Dsl.Compose.html","title":"Reactor.Dsl.Compose","type":"module"},{"doc":"","ref":"Reactor.Dsl.Compose.html#t:t/0","title":"Reactor.Dsl.Compose.t/0","type":"type"},{"doc":"The group DSL entity struct. See d:Reactor.group .","ref":"Reactor.Dsl.Group.html","title":"Reactor.Dsl.Group","type":"module"},{"doc":"","ref":"Reactor.Dsl.Group.html#t:t/0","title":"Reactor.Dsl.Group.t/0","type":"type"},{"doc":"The struct used to store input DSL entities. See d:Reactor.input .","ref":"Reactor.Dsl.Input.html","title":"Reactor.Dsl.Input","type":"module"},{"doc":"","ref":"Reactor.Dsl.Input.html#t:t/0","title":"Reactor.Dsl.Input.t/0","type":"type"},{"doc":"The struct used to store step DSL entities. See d:Reactor.step .","ref":"Reactor.Dsl.Step.html","title":"Reactor.Dsl.Step","type":"module"},{"doc":"","ref":"Reactor.Dsl.Step.html#t:t/0","title":"Reactor.Dsl.Step.t/0","type":"type"},{"doc":"Runs Reactor.Dsl.Build.verify/2 for all the entities in the reactor.","ref":"Reactor.Dsl.Verifier.html","title":"Reactor.Dsl.Verifier","type":"module"},{"doc":"An error used when attempting to compose to Reactors together.","ref":"Reactor.Error.ComposeError.html","title":"Reactor.Error.ComposeError","type":"exception"},{"doc":"An error thrown during the planning of a Reactor.","ref":"Reactor.Error.PlanError.html","title":"Reactor.Error.PlanError","type":"exception"},{"doc":"An error which occurs when building and running transforms.","ref":"Reactor.Error.TransformError.html","title":"Reactor.Error.TransformError","type":"exception"},{"doc":"The Reactor executor. The executor handles the main loop of running a Reactor. The algorithm is somewhat confusing, so here it is in pseudocode: Find any async tasks (from a previous loop) which are completed. Either recurse or continue if none are found. Find any async steps in the plan which are ready to run (they have no in-edges in the graph) and start as many as possible (given the constraints of max_concurrency and the state of the concurrency pool). Either start over, or continue if none are found. Find a single synchronous step which is ready to run and execute it. If there was one then recurse, otherwise continue. Check if there are no more steps left in the plan (there are zero vertices). If so, collect the return value and exit, otherwise recurse. Whenever a step is run, whether run synchronously or asynchronously, the following happens: When the step is successful: a. If the step is undoable (ie Step.can?(module, :undo)? returns true ) then the step and the result are stored in the Reactor's undo stack. b. If the result is depended upon by another step (the graph has out-edges for the step) or the step is asking the reactor to halt then the result is stored in the Reactor's intermediate results. c. The step is removed from the graph (along with it's out-edges, freeing up it's dependents to run). When the step is unsuccessful (returns an error tuple or raises): a. If the step can be compensated then compensation is attempted up to five times before giving up. b. The reactor iterates it's undo stack calling undo on each step. When a step or compensation asks for a retry then the step is placed back in the graph to be run again next iteration.","ref":"Reactor.Executor.html","title":"Reactor.Executor","type":"module"},{"doc":"Run a reactor. Provided a Reactor which has been planned and the correct inputs, then run the Reactor until completion, halting or failure. You probably shouldn't call this directly, but use Reactor.run/4 instead.","ref":"Reactor.Executor.html#run/4","title":"Reactor.Executor.run/4","type":"function"},{"doc":"Handle the asynchronous execution of a batch of steps, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Async.html","title":"Reactor.Executor.Async","type":"module"},{"doc":"When the Reactor needs to shut down for any reason, we need to await all the currently running asynchronous steps and delete any task vertices.","ref":"Reactor.Executor.Async.html#collect_remaining_tasks_for_shutdown/2","title":"Reactor.Executor.Async.collect_remaining_tasks_for_shutdown/2","type":"function"},{"doc":"Check to see if any steps are completed, and if so handle them.","ref":"Reactor.Executor.Async.html#handle_completed_steps/2","title":"Reactor.Executor.Async.handle_completed_steps/2","type":"function"},{"doc":"Start as many of the provided steps as possible. Takes into account he maximum concurrency and available work slots.","ref":"Reactor.Executor.Async.html#start_steps/4","title":"Reactor.Executor.Async.start_steps/4","type":"function"},{"doc":"Manage shared concurrency pools for multiple Reactors. When running a Reactor you can pass the concurrency_key option, which will cause the Reactor to use the specified pool to ensure that the combined Reactors never exceed the pool's available concurrency limit. This avoids nested Reactors spawning too many workers and thrashing the system.","ref":"Reactor.Executor.ConcurrencyTracker.html","title":"Reactor.Executor.ConcurrencyTracker","type":"module"},{"doc":"Attempt to acquire a concurrency allocation from the pool. Returns :ok if the allocation was successful, otherwise :error .","ref":"Reactor.Executor.ConcurrencyTracker.html#acquire/1","title":"Reactor.Executor.ConcurrencyTracker.acquire/1","type":"function"},{"doc":"Allocate a new concurrency pool and set the maximum limit.","ref":"Reactor.Executor.ConcurrencyTracker.html#allocate_pool/1","title":"Reactor.Executor.ConcurrencyTracker.allocate_pool/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Reactor.Executor.ConcurrencyTracker.html#child_spec/1","title":"Reactor.Executor.ConcurrencyTracker.child_spec/1","type":"function"},{"doc":"Release a concurrency allocation back to the pool.","ref":"Reactor.Executor.ConcurrencyTracker.html#release/1","title":"Reactor.Executor.ConcurrencyTracker.release/1","type":"function"},{"doc":"Release the concurrency pool. This deletes the pool, however doesn't affect any processes currently using it. No more resources can be acquired by users of the pool key.","ref":"Reactor.Executor.ConcurrencyTracker.html#release_pool/1","title":"Reactor.Executor.ConcurrencyTracker.release_pool/1","type":"function"},{"doc":"Report the available and maximum concurrency for a pool.","ref":"Reactor.Executor.ConcurrencyTracker.html#status/1","title":"Reactor.Executor.ConcurrencyTracker.status/1","type":"function"},{"doc":"","ref":"Reactor.Executor.ConcurrencyTracker.html#t:pool_key/0","title":"Reactor.Executor.ConcurrencyTracker.pool_key/0","type":"type"},{"doc":"Handle argument checking and state setup for a Reactor run.","ref":"Reactor.Executor.Init.html","title":"Reactor.Executor.Init","type":"module"},{"doc":"Contains the reactor execution state. This is run-time only information.","ref":"Reactor.Executor.State.html","title":"Reactor.Executor.State","type":"module"},{"doc":"","ref":"Reactor.Executor.State.html#t:t/0","title":"Reactor.Executor.State.t/0","type":"type"},{"doc":"Run an individual step, including compensation if possible.","ref":"Reactor.Executor.StepRunner.html","title":"Reactor.Executor.StepRunner","type":"module"},{"doc":"Collect the arguments and and run a step, with compensation if required.","ref":"Reactor.Executor.StepRunner.html#run/3","title":"Reactor.Executor.StepRunner.run/3","type":"function"},{"doc":"Undo a step if possible.","ref":"Reactor.Executor.StepRunner.html#undo/4","title":"Reactor.Executor.StepRunner.undo/4","type":"function"},{"doc":"Handle the synchronous execution of a single step, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Sync.html","title":"Reactor.Executor.Sync","type":"module"},{"doc":"Try and run a step synchronously.","ref":"Reactor.Executor.Sync.html#run/3","title":"Reactor.Executor.Sync.run/3","type":"function"},{"doc":"Introspection for the Reactor DSL.","ref":"Reactor.Info.html","title":"Reactor.Info","type":"module"},{"doc":"reactor DSL entities","ref":"Reactor.Info.html#reactor/1","title":"Reactor.Info.reactor/1","type":"function"},{"doc":"reactor DSL options Returns a map containing the and any configured or default values.","ref":"Reactor.Info.html#reactor_options/1","title":"Reactor.Info.reactor_options/1","type":"function"},{"doc":"Specify which step result to return upon completion.","ref":"Reactor.Info.html#reactor_return/1","title":"Reactor.Info.reactor_return/1","type":"function"},{"doc":"Specify which step result to return upon completion.","ref":"Reactor.Info.html#reactor_return!/1","title":"Reactor.Info.reactor_return!/1","type":"function"},{"doc":"Convert a reactor DSL module into a reactor struct.","ref":"Reactor.Info.html#to_struct/1","title":"Reactor.Info.to_struct/1","type":"function"},{"doc":"Raising version of to_struct/1 .","ref":"Reactor.Info.html#to_struct!/1","title":"Reactor.Info.to_struct!/1","type":"function"},{"doc":"Build an execution plan for a Reactor. Converts any unplanned steps into vertices in a graph with directed edges between them representing their dependencies (arguments).","ref":"Reactor.Planner.html","title":"Reactor.Planner","type":"module"},{"doc":"Build an execution plan for a Reactor. Builds a graph of the step dependencies, resolves them and then builds an execution plan.","ref":"Reactor.Planner.html#plan/1","title":"Reactor.Planner.plan/1","type":"function"},{"doc":"Raising version of plan/1 .","ref":"Reactor.Planner.html#plan!/1","title":"Reactor.Planner.plan!/1","type":"function"},{"doc":"The input template.","ref":"Reactor.Template.Input.html","title":"Reactor.Template.Input","type":"module"},{"doc":"","ref":"Reactor.Template.Input.html#t:t/0","title":"Reactor.Template.Input.t/0","type":"type"},{"doc":"The result template.","ref":"Reactor.Template.Result.html","title":"Reactor.Template.Result","type":"module"},{"doc":"","ref":"Reactor.Template.Result.html#t:t/0","title":"Reactor.Template.Result.t/0","type":"type"},{"doc":"A statically value template.","ref":"Reactor.Template.Value.html","title":"Reactor.Template.Value","type":"module"},{"doc":"","ref":"Reactor.Template.Value.html#t:t/0","title":"Reactor.Template.Value.t/0","type":"type"},{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Woah. That's a lot. Let's break it down: Saga orchestrator A saga is a way of providing transaction-like semantics across multiple distinct resources. Dependency resolving reactor allows you to describe the dependencies between your saga steps using arguments which are converted into a DAG and used to compute execution order. Concurrent unless otherwise specified reactor will run as many steps as possible concurrently whilst taking into account the results of the dependency resolution. Dynamic whilst you can define a reactor statically using our awesome DSL, you can also build workflows dynamically - and even add steps while the reactor is running. saga pattern","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"Thanks to Alembic Pty Ltd for sponsoring a portion of this project's development.","ref":"readme.html#sponsors","title":"Read Me - Sponsors","type":"extras"},{"doc":"The package can be installed by adding reactor to your list of dependencies in mix.exs : def deps do [ { :reactor , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"Read Me - Installation","type":"extras"},{"doc":"Documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"Read Me - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on the #reactor channel on the Ash Discord .","ref":"readme.html#contributing","title":"Read Me - Contributing","type":"extras"},{"doc":"reactor is licensed under the terms of the MIT license . See the LICENSE file in this repository for details.","ref":"readme.html#licence","title":"Read Me - Licence","type":"extras"},{"doc":"Reactor is a lot of things: A saga orchestrator . A composable DSL for creating workflows. A builder for dynamically creating workflows. Capable of mixing concurrent and serialised workflows. Resolves dependencies between tasks using a directed acyclic graph . Let's start by breaking down what each of these features are, and how we can use them.","ref":"getting-started-with-reactor.html","title":"Getting started with Reactor","type":"extras"},{"doc":"If you've been building apps long enough you will have used database transactions. They're amazing. Basically, if you put all your changes in a transaction and there's a failure then the transaction gets rolled back and the system is not left in an inconsistent state. This is great when you're working with a single database, but in the modern world we often have to integrate with many different kinds of data stores and as many different SaaS products . Often we need to orchestrate a &quot;transaction&quot; across multiple services at once; for example: Register a new user Create a Stripe customer Create a Stripe subscription Send a transactional welcome email via SendGrid Track the conversion in Salesforce If any of these steps fails we may want to retry or roll back depending on what failed and whether it's recoverable. Reactor allows us to do this by defining the Reactor.Step behaviour: defmodule MyApp.CreateStripeSubscriptionStep do use Reactor.Step @impl true def run ( arguments , context , options ) do Stripe.Subscription . create ( arguments . stripe_customer_id , items : [ plan : arguments . stripe_plan_id ] ) end @impl true def compensate ( %{ code : :network_error } , arguments , context , options ) do :retry end def compensate ( error , arguments , context , options ) do :ok end @impl true def undo ( subscription , arguments , context , options ) do case Stripe.Subscription . delete ( subscription ) do { :ok , _ } -&gt; :ok { :error , reason } -&gt; { :error , reason } end end end Here we've defined a step that tries to create a new Stripe subscription. If that fails then we have defined compensate/4 check whether it was a network error, and if so ask the Reactor to retry, otherwise we return :ok because the subscription wasn't created so we don't have to do any other clean up. Lastly, we define undo/4 to delete the subscription if the Reactor asks us to undo our work - which it will do if a step later in the workflow fails. How do you compose these steps together you ask? Let's discuss that in the next section.","ref":"getting-started-with-reactor.html#transaction-like-semantics-with-sagas","title":"Getting started with Reactor - Transaction-like semantics with Sagas","type":"extras"},{"doc":"Reactor uses spark to define an easy to use (and easy to extend) DSL for defining workflows. Let's start with an example: defmodule MyApp.RegisterUserReactor do use Reactor input :email input :password input :plan_name step :register_user , MyApp.RegisterUserStep do argument :email , input ( :email ) argument :password , input ( :password ) end step :create_stripe_customer , MyApp.CreateStripeCustomerStep do argument :email , input ( :email ) end step :find_stripe_plan , MyApp.FindStripePlanStep do argument :plan_name , input ( :plan_name ) end step :create_stripe_subscription , MyApp.CreateStripeSubscriptionStep do argument :customer_id do source result ( :create_stripe_customer ) transform &amp; ( &amp;1 . id ) end argument :plan_id do source result ( :get_stripe_plan ) transform &amp; ( &amp;1 . id ) end end step :send_welcome_email , MyApp.SendWelcomeEmailStep do argument :email , input ( :email ) argument :_subscription , result ( :create_stripe_subscription ) end step :track_conversion , MyApp.TrackSalesforceConversionStep do argument :email , input ( :email ) argument :plan_name , input ( :plan_name ) argument :_welcome_email , result ( :send_welcome_email ) end return :register_user end Here we've defined a Reactor that performs the steps needed for the user registration example above. Here we define the steps that need to be performed and describe the dependencies between them by way of arguments. Beware of ordering Whilst the order of the steps in the example makes sense logically it has no effect on the order that the Reactor will execute them in. This is the fundamental difference between Reactor and other Saga tools in the Elixir ecosystem. The Reactor will put the steps into a graph with the steps as vertices and the arguments as edges and will find any that have no inbound edges and run as many of them at once as possible. This means that :register_user , :create_stripe_customer and :find_stripe_plan will all execute simultaneously, after which :create_stripe_subscription , then :send_welcome_email and :track_conversion will run. Notice that :send_welcome_email and :track_conversion have arguments that depend on the results of previews steps that they don't necessarily need, however we want to ensure that they don't run until all the important steps are complete (it's hard to unsend an email!)","ref":"getting-started-with-reactor.html#composing-steps-with-the-reactor-dsl","title":"Getting started with Reactor - Composing steps with the Reactor DSL","type":"extras"},{"doc":"While using the DSL makes it extremely easy to build a static workflow, sometimes you need the flexibility to build a workflow based on a set of criteria that may not be known at compile time (for example if you're using user input to build the workflow). Every Reactor is ultimately an instance of the Reactor struct (you can use Reactor.Info.to_struct(MyApp.RegisterUserReactor) to see the one for the DSL Reactor above). The functions in Reactor.Builder can be used to create an identical workflow: iex&gt; reactor = Reactor.Builder . new ( ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :email ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :password ) ...&gt; { :ok , reactor } = Reactor.Builder . add_input ( reactor , :plan_name ) ...&gt; { :ok , reactor } = Reactor.Builder . add_step ( reactor , :register_user , MyApp.RegisterUserStep , email : { :input , :email } , password : { :input , :password } ) # etc...","ref":"getting-started-with-reactor.html#building-workflows-programmatically","title":"Getting started with Reactor - Building workflows programmatically","type":"extras"},{"doc":"If you look at the Reactor.Step struct, you'll see that it has an async? field. This is available as a step DSL option, and as an option to add_step/5 . It defaults to true , however if you set it to false Reactor will run the step synchronously. Note that it will only run synchronous steps when it has run out of async steps which can be started. Other than that caveat, Reactor will follow the same ordering rules as specified above.","ref":"getting-started-with-reactor.html#mixing-concurrent-and-synchronous-workflow-steps","title":"Getting started with Reactor - Mixing concurrent and synchronous workflow steps","type":"extras"},{"doc":"You can pass either a Reactor DSL module or a Reactor struct straight into the Reactor.run/1..4 function.","ref":"getting-started-with-reactor.html#running-your-reactor","title":"Getting started with Reactor - Running your Reactor","type":"extras"},{"doc":"Any step in the flow can return {:halt, value} instead of {:ok, value} . When this happens Reactor will wait for any running asynchronous steps to finish and then halt the Reactor returning {:halted, reactor} . Later on you can resume the Reactor by passing the halted reactor to the Reactor.run/1..4 function.","ref":"getting-started-with-reactor.html#halting-and-resuming-workflows","title":"Getting started with Reactor - Halting and resuming workflows","type":"extras"},{"doc":"Any step can return {:ok, value, additional_steps} instead of just {:ok, value} and those new steps will be added to the graph and have their dependencies calculated automatically. additional_steps should be a list of Reactor.Step structs, which you can create with Reactor.Builder.new_step/2..4 . There are a couple of additional things to be aware of when steps at run time: If you add steps that induce a cyclic dependency then the Reactor will commence an undo, just as if a step had failed. Steps can have the same name as other steps and their intermediate results will be replaced. You are allowed to make dependency cycles in the very specific case of a new step relying on it's own output.","ref":"getting-started-with-reactor.html#dynamically-adding-steps-at-reactor-run-time","title":"Getting started with Reactor - Dynamically adding steps at Reactor run time","type":"extras"}]