sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"sponsors","id":"Sponsors"},{"anchor":"installation","id":"Installation"},{"anchor":"documentation","id":"Documentation"},{"anchor":"contributing","id":"Contributing"},{"anchor":"licence","id":"Licence"}],"id":"readme","title":"Read Me"},{"group":"Tutorials","headers":[{"anchor":"transaction-like-semantics-with-sagas","id":"Transaction-like semantics with Sagas"},{"anchor":"composing-steps-with-the-reactor-dsl","id":"Composing steps with the Reactor DSL"},{"anchor":"building-workflows-programmatically","id":"Building workflows programmatically"},{"anchor":"mixing-concurrent-and-synchronous-workflow-steps","id":"Mixing concurrent and synchronous workflow steps"},{"anchor":"running-your-reactor","id":"Running your Reactor"},{"anchor":"halting-and-resuming-workflows","id":"Halting and resuming workflows"},{"anchor":"dynamically-adding-steps-at-reactor-run-time","id":"Dynamically adding steps at Reactor run time"}],"id":"getting-started-with-reactor","title":"Getting started with Reactor"}],"modules":[{"group":"","id":"Reactor","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:async_option/0","id":"async_option/0","title":"async_option()"},{"anchor":"t:concurrency_key_option/0","id":"concurrency_key_option/0","title":"concurrency_key_option()"},{"anchor":"t:context/0","id":"context/0","title":"context()"},{"anchor":"t:context_arg/0","id":"context_arg/0","title":"context_arg()"},{"anchor":"t:halt_timeout_option/0","id":"halt_timeout_option/0","title":"halt_timeout_option()"},{"anchor":"t:inputs/0","id":"inputs/0","title":"inputs()"},{"anchor":"t:max_concurrency_option/0","id":"max_concurrency_option/0","title":"max_concurrency_option()"},{"anchor":"t:max_iterations_option/0","id":"max_iterations_option/0","title":"max_iterations_option()"},{"anchor":"t:options/0","id":"options/0","title":"options()"},{"anchor":"t:state/0","id":"state/0","title":"state()"},{"anchor":"t:t/0","id":"t/0","title":"t()"},{"anchor":"t:timeout_option/0","id":"timeout_option/0","title":"timeout_option()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"run/4","id":"run/4","title":"run(reactor, inputs \\\\ %{}, context \\\\ %{}, options \\\\ [])"}]}],"sections":[{"anchor":"module-usage","id":"Usage"},{"anchor":"module-dsl-documentation","id":"DSL Documentation"},{"anchor":"module-reactor","id":"reactor"}],"title":"Reactor"},{"group":"Steps","id":"Reactor.Step","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:capability/0","id":"capability/0","title":"capability()"},{"anchor":"t:compensate_result/0","id":"compensate_result/0","title":"compensate_result()"},{"anchor":"t:run_result/0","id":"run_result/0","title":"run_result()"},{"anchor":"t:step/0","id":"step/0","title":"step()"},{"anchor":"t:t/0","id":"t/0","title":"t()"},{"anchor":"t:undo_result/0","id":"undo_result/0","title":"undo_result()"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:compensate/4","id":"compensate/4","title":"compensate(reason, arguments, context, options)"},{"anchor":"c:run/3","id":"run/3","title":"run(arguments, context, options)"},{"anchor":"c:undo/4","id":"undo/4","title":"undo(value, arguments, context, options)"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"can?/2","id":"can?/2","title":"can?(module, capability)"},{"anchor":"compensate/4","id":"compensate/4","title":"compensate(map, reason, arguments, context)"},{"anchor":"run/3","id":"run/3","title":"run(map, arguments, context)"},{"anchor":"undo/4","id":"undo/4","title":"undo(map, value, arguments, context)"}]}],"sections":[],"title":"Reactor.Step"},{"group":"Steps","id":"Reactor.Step.AnonFn","sections":[],"title":"Reactor.Step.AnonFn"},{"group":"Steps","id":"Reactor.Step.Around","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:allow_async_option/0","id":"allow_async_option/0","title":"allow_async_option()"},{"anchor":"t:around_fun/0","id":"around_fun/0","title":"around_fun()"},{"anchor":"t:callback/0","id":"callback/0","title":"callback()"},{"anchor":"t:function_option/0","id":"function_option/0","title":"function_option()"},{"anchor":"t:options/0","id":"options/0","title":"options()"},{"anchor":"t:steps_option/0","id":"steps_option/0","title":"steps_option()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"around/4","id":"around/4","title":"around(arguments, context, steps, options)"}]}],"sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-wrapper-function","id":"Wrapper function"},{"anchor":"module-callback-function","id":"Callback function"},{"anchor":"module-example","id":"Example"}],"title":"Reactor.Step.Around"},{"group":"Steps","id":"Reactor.Step.Compose","sections":[],"title":"Reactor.Step.Compose"},{"group":"Steps","id":"Reactor.Step.ComposeWrapper","sections":[{"anchor":"module-options","id":"Options"}],"title":"Reactor.Step.ComposeWrapper"},{"group":"Steps","id":"Reactor.Step.Group","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:after_fun/0","id":"after_fun/0","title":"after_fun()"},{"anchor":"t:after_option/0","id":"after_option/0","title":"after_option()"},{"anchor":"t:allow_async_option/0","id":"allow_async_option/0","title":"allow_async_option()"},{"anchor":"t:before_fun/0","id":"before_fun/0","title":"before_fun()"},{"anchor":"t:before_option/0","id":"before_option/0","title":"before_option()"},{"anchor":"t:options/0","id":"options/0","title":"options()"},{"anchor":"t:steps_option/0","id":"steps_option/0","title":"steps_option()"}]}],"sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-before-function","id":"Before function"},{"anchor":"module-after-function","id":"After function"}],"title":"Reactor.Step.Group"},{"group":"Steps","id":"Reactor.Step.ReturnAllArguments","sections":[],"title":"Reactor.Step.ReturnAllArguments"},{"group":"Steps","id":"Reactor.Step.Transform","sections":[],"title":"Reactor.Step.Transform"},{"group":"Steps","id":"Reactor.Step.TransformAll","sections":[],"title":"Reactor.Step.TransformAll"},{"group":"Internals","id":"Reactor.Argument","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"from_input/3","id":"from_input/3","title":"from_input(name, input_name, transform \\\\ nil)"},{"anchor":"from_result/3","id":"from_result/3","title":"from_result(name, result_name, transform \\\\ nil)"},{"anchor":"from_value/3","id":"from_value/3","title":"from_value(name, value, transform \\\\ nil)"},{"anchor":"has_transform/1","id":"has_transform/1","title":"has_transform(argument)"},{"anchor":"is_argument/1","id":"is_argument/1","title":"is_argument(argument)"},{"anchor":"is_from_input/1","id":"is_from_input/1","title":"is_from_input(argument)"},{"anchor":"is_from_result/1","id":"is_from_result/1","title":"is_from_result(argument)"},{"anchor":"is_from_value/1","id":"is_from_value/1","title":"is_from_value(argument)"}]}],"sections":[],"title":"Reactor.Argument"},{"group":"Internals","id":"Reactor.Argument.Build","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"build/1","id":"build/1","title":"build(input)"}]}],"sections":[],"title":"Reactor.Argument.Build"},{"group":"Internals","id":"Reactor.Builder","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:arguments_transform/0","id":"arguments_transform/0","title":"arguments_transform()"},{"anchor":"t:async?/0","id":"async?/0","title":"async?()"},{"anchor":"t:context/0","id":"context/0","title":"context()"},{"anchor":"t:impl/0","id":"impl/0","title":"impl()"},{"anchor":"t:max_retries/0","id":"max_retries/0","title":"max_retries()"},{"anchor":"t:ref/0","id":"ref/0","title":"ref()"},{"anchor":"t:step_argument/0","id":"step_argument/0","title":"step_argument()"},{"anchor":"t:step_options/0","id":"step_options/0","title":"step_options()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"add_input/3","id":"add_input/3","title":"add_input(reactor, name, transform \\\\ nil)"},{"anchor":"add_input!/3","id":"add_input!/3","title":"add_input!(reactor, name, transform \\\\ nil)"},{"anchor":"add_step/5","id":"add_step/5","title":"add_step(reactor, name, impl, arguments \\\\ [], options \\\\ [])"},{"anchor":"add_step!/5","id":"add_step!/5","title":"add_step!(reactor, name, impl, arguments \\\\ [], options \\\\ [])"},{"anchor":"compose/4","id":"compose/4","title":"compose(reactor, name, inner_reactor, arguments)"},{"anchor":"compose!/4","id":"compose!/4","title":"compose!(reactor, name, inner_reactor, arguments)"},{"anchor":"new/1","id":"new/1","title":"new(id \\\\ make_ref())"},{"anchor":"new_step/4","id":"new_step/4","title":"new_step(name, impl, arguments \\\\ [], options \\\\ [])"},{"anchor":"new_step!/4","id":"new_step!/4","title":"new_step!(name, impl, arguments \\\\ [], options \\\\ [])"},{"anchor":"return/2","id":"return/2","title":"return(reactor, name)"},{"anchor":"return!/2","id":"return!/2","title":"return!(reactor, name)"}]}],"sections":[{"anchor":"module-example","id":"Example"}],"title":"Reactor.Builder"},{"group":"Internals","id":"Reactor.Builder.Compose","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"compose/4","id":"compose/4","title":"compose(reactor, name, inner_reactor, arguments)"},{"anchor":"do_static_compose/4","id":"do_static_compose/4","title":"do_static_compose(reactor, name, inner_reactor, arguments)"}]}],"sections":[],"title":"Reactor.Builder.Compose"},{"group":"Internals","id":"Reactor.Builder.Input","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"add_input/3","id":"add_input/3","title":"add_input(reactor, name, transform)"}]}],"sections":[],"title":"Reactor.Builder.Input"},{"group":"Internals","id":"Reactor.Builder.Step","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"add_step/5","id":"add_step/5","title":"add_step(reactor, name, impl, arguments, options)"},{"anchor":"new_step/4","id":"new_step/4","title":"new_step(name, impl, arguments, options)"}]}],"sections":[],"title":"Reactor.Builder.Step"},{"group":"Internals","id":"Reactor.Dsl.Argument","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"input/1","id":"input/1","title":"input(input_name)"},{"anchor":"result/1","id":"result/1","title":"result(link_name)"},{"anchor":"value/1","id":"value/1","title":"value(value)"}]}],"sections":[],"title":"Reactor.Dsl.Argument"},{"group":"Internals","id":"Reactor.Dsl.Around","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Dsl.Around"},{"group":"Internals","id":"Reactor.Dsl.Build","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"build/2","id":"build/2","title":"build(entity, reactor)"},{"anchor":"transform/2","id":"transform/2","title":"transform(entity, dsl_state)"},{"anchor":"verify/2","id":"verify/2","title":"verify(entity, dsl_state)"}]}],"sections":[],"title":"Reactor.Dsl.Build"},{"group":"Internals","id":"Reactor.Dsl.Compose","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Dsl.Compose"},{"group":"Internals","id":"Reactor.Dsl.Group","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Dsl.Group"},{"group":"Internals","id":"Reactor.Dsl.Input","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Dsl.Input"},{"group":"Internals","id":"Reactor.Dsl.Step","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Dsl.Step"},{"group":"Internals","id":"Reactor.Dsl.Verifier","sections":[],"title":"Reactor.Dsl.Verifier"},{"group":"Internals","id":"Reactor.Error.ComposeError","sections":[],"title":"Reactor.Error.ComposeError"},{"group":"Internals","id":"Reactor.Error.PlanError","sections":[],"title":"Reactor.Error.PlanError"},{"group":"Internals","id":"Reactor.Error.TransformError","sections":[],"title":"Reactor.Error.TransformError"},{"group":"Internals","id":"Reactor.Executor","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"run/4","id":"run/4","title":"run(reactor, inputs \\\\ %{}, context \\\\ %{}, options \\\\ [])"}]}],"sections":[],"title":"Reactor.Executor"},{"group":"Internals","id":"Reactor.Executor.Async","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"collect_remaining_tasks_for_shutdown/2","id":"collect_remaining_tasks_for_shutdown/2","title":"collect_remaining_tasks_for_shutdown(reactor, state)"},{"anchor":"handle_completed_steps/2","id":"handle_completed_steps/2","title":"handle_completed_steps(reactor, state)"},{"anchor":"start_steps/4","id":"start_steps/4","title":"start_steps(reactor, state, steps, supervisor \\\\ {:via, PartitionSupervisor, {Reactor.TaskSupervisor, self()}})"}]}],"sections":[],"title":"Reactor.Executor.Async"},{"group":"Internals","id":"Reactor.Executor.ConcurrencyTracker","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:pool_key/0","id":"pool_key/0","title":"pool_key()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"acquire/1","id":"acquire/1","title":"acquire(key)"},{"anchor":"allocate_pool/1","id":"allocate_pool/1","title":"allocate_pool(concurrency_limit)"},{"anchor":"child_spec/1","id":"child_spec/1","title":"child_spec(init_arg)"},{"anchor":"release/1","id":"release/1","title":"release(key)"},{"anchor":"release_pool/1","id":"release_pool/1","title":"release_pool(pool_key)"},{"anchor":"status/1","id":"status/1","title":"status(key)"}]}],"sections":[],"title":"Reactor.Executor.ConcurrencyTracker"},{"group":"Internals","id":"Reactor.Executor.Init","sections":[],"title":"Reactor.Executor.Init"},{"group":"Internals","id":"Reactor.Executor.State","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Executor.State"},{"group":"Internals","id":"Reactor.Executor.StepRunner","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"run/3","id":"run/3","title":"run(reactor, step, concurrency_key)"},{"anchor":"undo/4","id":"undo/4","title":"undo(reactor, step, value, concurrency_key)"}]}],"sections":[],"title":"Reactor.Executor.StepRunner"},{"group":"Internals","id":"Reactor.Executor.Sync","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"run/3","id":"run/3","title":"run(reactor, state, step)"}]}],"sections":[],"title":"Reactor.Executor.Sync"},{"group":"Internals","id":"Reactor.Info","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"reactor/1","id":"reactor/1","title":"reactor(dsl_or_extended)"},{"anchor":"reactor_options/1","id":"reactor_options/1","title":"reactor_options(dsl_or_extended)"},{"anchor":"reactor_return/1","id":"reactor_return/1","title":"reactor_return(dsl_or_extended)"},{"anchor":"reactor_return!/1","id":"reactor_return!/1","title":"reactor_return!(dsl_or_extended)"},{"anchor":"to_struct/1","id":"to_struct/1","title":"to_struct(reactor)"},{"anchor":"to_struct!/1","id":"to_struct!/1","title":"to_struct!(reactor)"}]}],"sections":[],"title":"Reactor.Info"},{"group":"Internals","id":"Reactor.Planner","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"plan/1","id":"plan/1","title":"plan(reactor)"},{"anchor":"plan!/1","id":"plan!/1","title":"plan!(reactor)"}]}],"sections":[],"title":"Reactor.Planner"},{"group":"Internals","id":"Reactor.Template.Input","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Template.Input"},{"group":"Internals","id":"Reactor.Template.Result","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Template.Result"},{"group":"Internals","id":"Reactor.Template.Value","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]}],"sections":[],"title":"Reactor.Template.Value"}],"tasks":[]}